var canBeAssignedField = Ext.getCmp('{{ component.field__can_be_assigned.client_id }}');
canBeAssignedField.label.setWidth(225);

var partitionsGrid = Ext.getCmp('{{ component.grid__partitions.client_id }}');
var partitionsStore = partitionsGrid.getStore();
var partitionsSM = partitionsGrid.getSelectionModel();

var permissionsGrid = Ext.getCmp('{{ component.grid__permissions.client_id }}');
var permissionsStore = permissionsGrid.getStore();
var permissionsSM = permissionsGrid.getSelectionModel();

var rolePermissions = {{ component.permission_ids }};

var descriptionPanel = Ext.getCmp('{{ component.panel__description.client_id }}');

var canEdit = {{ component.can_edit }};


function columnRenderer(value, metaData, record, rowIndex, colIndex, store) {
    if (rolePermissions.indexOf(record.id) == -1) {
        metaData.attr = 'style="color: #777;"';
    }
    return value;
}

function permissionsGridUpdate() {
    if (partitionsSM.hasSelection()) {
        var partitionId = partitionsSM.getSelected().json.id;
        permissionsStore.setBaseParam('partition_id', partitionId);
        permissionsStore.lastOptions = null;
        permissionsStore.reload();
    } else {
        permissionsStore.setBaseParam('partition_id', null);
        permissionsStore.removeAll();
        permissionsGrid.getSelectionModel().unlock();
    }
}

partitionsSM.on('selectionchange', permissionsGridUpdate);
partitionsStore.on('load', permissionsGridUpdate);

permissionsSM.on('rowselect', function (sm, rowIndex, record) {
    if (rolePermissions.indexOf(record.id) == -1) {
        rolePermissions.push(record.id);
    }
});

permissionsSM.on('rowdeselect', function (sm, rowIndex, record) {
    if (rolePermissions.indexOf(record.id) != -1) {
        rolePermissions.splice(rolePermissions.indexOf(record.id), 1);
    }
});

permissionsStore.on('load', function (store, records, options) {
    var selectedRecords = [];

    for (var i = 0; i < records.length; i++) {
        var record = records[i];
        if (rolePermissions.indexOf(record.id) != -1) {
            selectedRecords.push(record);
        }
    }

    permissionsSM.suspendEvents();
    permissionsSM.selectRecords(selectedRecords);

   if (!canEdit) {
        permissionsGrid.getSelectionModel().lock();
    }
    permissionsSM.resumeEvents();
});

win.on('beforesubmit', function(action) {
    action.params['permissions'] = rolePermissions.join(',');
});
/* ------------------------------------------------------------------------- */

permissionsStore.on('load', function(store, records) {
    for (var i = 0; i < records.length; i++) {
        var record = records[i];
        var rowElement = Ext.get(permissionsGrid.view.getRow(i));

        rowElement.on('mouseenter', function() {
            var record = this;
            descriptionPanel.update(
                record.data.description ?
                record.data.description.replace(/\n/g, '<br/>') : ''
            );
        }, record);

        rowElement.on('mouseleave', function() {
            descriptionPanel.update('');
        }, record);
    }
});
/* ------------------------------------------------------------------------- */
